#include <stdio.h>
#include <math.h>
                    // 以下は電卓での操作（[MR]はメモリ呼び出し）
double cbrt4(double x) { // (A)      // xをメモリに記憶
    double a1 = 1.0;                 // [1]
    double a2 = sqrt(sqrt(x * a1));  // [×][MR][＝][√][√]
    double a3 = sqrt(sqrt(x * a2));  // [×][MR][＝][√][√]
    double a4 = sqrt(sqrt(x * a3));  // [×][MR][＝][√][√]
    return a4;
} // よく考えるとa1,a2,a3,a4は同じ変数でもよい

double cbrt10(double x) { // (B)     // xをメモリに記憶
    double a = 1.0; // 初項a1        // [1]
    for (int i=2; i<=10; i++) {
        a = sqrt(sqrt(x * a));       // [×][MR][＝][√][√]
    }
    return a;
}

#define EPS 0.001   // 許容誤差
double cbrt_eps(double x) { // (C)
    double a = 1.0;
    while (fabs(a*a*a - x) > EPS) {  // aの3乗とxの差の絶対値を比較
        a = sqrt(sqrt(x * a));
    }
    return a;
}

int main(void) {
    double x = 8.0;
    printf("cbrt=%f, cbrt4=%f, cbrt10=%f, cbrt_eps=%f\n",
            cbrt(x), cbrt4(x), cbrt10(x), cbrt_eps(x));
    return 0;
}
