#include <stdio.h>
#include <math.h>

/* 点を表す構造体 */    // 関数定義やプロトタイプ宣言よりも前に必要
struct point {
    double x, y;
};


/* 原点からpまでの距離を返す */
double point_dist(struct point p) {
    return sqrt(p.x*p.x + p.y*p.y); // .(ドット)でメンバーを取り出す
}

/* 原点からpまでの距離を表示する */
void point_print_dist(struct point p) {
    printf("原点と(%g,%g)の距離は%fです。\n",
           p.x, p.y, point_dist(p));
}

int main(void) {
    struct point p1 = { 1.0, 2.0 },
                 p2 = { 9.0, 8.0 };
    point_print_dist(p1); // 原点と(1,2)の距離は2.236068です。
    point_print_dist(p2); // 原点と(9,8)の距離は12.041595です。
    return 0;
}
