#include <stdio.h>
#include <math.h>

/* 点を表す構造体 */
struct point {
    double x, y;
    char label[16]; // 追加
};

/* 原点からpまでの距離を返す */
double point_dist(struct point p) {
    return sqrt(p.x*p.x + p.y*p.y);
}

/* 原点からpまでの距離を表示する */
void point_print_dist(struct point p) {
    printf("原点と点%s(%g,%g)の距離は%fです。\n", // 点%s 追加
           p.label, p.x, p.y, point_dist(p));    // p.label 追加
}

int main(void) {
    struct point p1 = { 1.0, 2.0, "A" }, // "A" 追加
                 p2 = { 9.0, 8.0, "B" }; // "B" 追加
    point_print_dist(p1); // 原点と点A(1,2)の距離は2.236068です。
    point_print_dist(p2); // 原点と点B(9,8)の距離は12.041595です。
    return 0;
}
