#include <math.h>  // fabs(), fmax()
#include <float.h> // DBL_EPSILON

/* 等しいとみなす相対誤差 */
#define RELATIVE_ERROR (DBL_EPSILON * 8)

/* xとyがほぼ等しければ0, x>yなら正, x<yなら負を返す */
int fcmp(double x, double y) {
    double diff = x - y;
    double max  = fmax(fabs(x), fabs(y));        // 絶対値の大きい方
    if (fabs(diff) < max * RELATIVE_ERROR) return 0; // 許容誤差以下
    if (diff > 0) { return +1; } else { return -1; }
}
